### *** This interface provides Binary Compatibility only, not Source Compatibility ***

Package com.sas.services.information.metadata

# Interface HttpServerInterface

All Superinterfaces:
  `MetadataInterface`, `PublicObjectInterface`, `Remote`, `ServerComponentInterface`, `ServerInterface`, `SoftwareComponentInterface`

@SASScope("ALL") @BinaryCompatibilityOnly public interface HttpServerInterface extends ServerComponentInterface
This is a generic interface for interacting with a repository entry that represents an HTTP server of some sort.

Since:
  1.0

- ## Field Summary

  Fields
  Modifier and Type
  Field
  Description
  `static final String`
  `METADATA_AUTHENTICATION_TYPE`
  Constant used for the value of the `AuthenticationType` attribute of a `TCPIPConnection` to denote the type of authentication for this server.
  `static final String`
  `NONE_AUTHENTICATION_TYPE`
  Constant used for the value of the `AuthenticationType` attribute of a `TCPIPConnection` to denote the type of authentication for this server.
  `static final String`
  `USERPASS_AUTHENTICATION_TYPE`
  Constant used for the value of the `AuthenticationType` attribute of a `TCPIPConnection` to denote the type of authentication for this server.

  ### Fields inherited from interface com.sas.services.information.metadata.MetadataInterface

  `METADATA_STATE_DELETED, METADATA_STATE_DESTROYED, METADATA_STATE_NEW, METADATA_STATE_NORMAL, PERMISSION_READMETADATA, PERMISSION_WRITEMETADATA`

- ## Method Summary

  Modifier and Type
  Method
  Description
  `String`
  `getAuthenticationType()`
  Get the authentication type string for the connection.
  `List`
  `getDomains()`
  Get a list of the authentication domains that the server is running in.
  `String`
  `getProxyUrl()`
  Get the proxy url.
  `String`
  `getUrl()`
  Get the url for this HTTP server.
  `void`
  `setAuthenticationType(String authType)`
  Set the authentication type string.
  `void`
  `setProxyUrl(String proxyUrl)`
  Set the proxy url for this HTTP server.

  ### Methods inherited from interface com.sas.services.information.metadata.MetadataInterface

  `add, addAccessControl, addAttribute, addAttributes, addDocument, addExtension, addGroup, addImplementor, addKeyword, addNoteTextStore, addNoteTextStore, addObjectProperty, addObjectProperty, addPermissions, addPrompt, addPropertySet, addRemark, addResponsibleParty, addTransactionListener, addUsedByPrototype, checkin, checkout, commit, copyTo, countAssociatedObjects, delete, deleteAttribute, deleteAttributes, destroy, getAccessControls, getAttribute, getAttributes, getAuthorizationUtil, getCreateDate, getCreatedBy, getDescription, getDocuments, getEntityKey, getEntityURL, getExtensions, getGroups, getGUID, getIdentities, getImplementors, getKeywords, getLockedBy, getModifiedBy, getModifyDate, getNoteTextStore, getNoteTextStores, getNoteTextStoresByRole, getObjectProperties, getParent, getParentPath, getParents, getPath, getPaths, getPermission, getPermissions, getPermissions, getPreviousVersionNames, getPrimaryPropertyGroup, getPrompt, getPrompts, getPropertyBag, getPropertySets, getRemarksList, getReposId, getRepository, getRepositoryEntity, getRepositoryName, getReposKey, getResponsibleParties, getState, getTrackingId, getType, getUsageVersion, getUsedByPrototypes, getUsingPrototype, getVersion, isAuthorized, isCompatible, isDeleted, isDestroyed, isObjectAlive, isReadCompatible, mapNameToFilesystem, mapUrlToFilesystem, moveTo, newServiceObject, refresh, removeAccessControl, removeDocument, removeExtension, removeGroup, removeImplementor, removeKeyword, removeNoteTextStore, removeObjectProperty, removePermissions, removePrompt, removePropertySet, removeResponsibleParty, removeResponsiblePartyByIdentity, removeUsedByPrototype, rollback, setAttribute, setAttributes, setDeleted, setDescription, setDocuments, setExtensions, setGroups, setGUID, setKeywords, setName, setNoteTextStores, setObjectProperties, setPermission, setPrimaryPropertyGroup, setPrompt, setPrompts, setRemarksList, setRepository, setUsingPrototype, startTransaction, toByteArray, transactionEvent, uncheckout, update, updateFromBag, version`

  ### Methods inherited from interface com.sas.services.information.publicobject.PublicObjectInterface

  `addProcessorInterface, getContainer, getIdentifier, getName, getObjectURI, getPathUrl, getProcessorInterface, getTypeDescriptor`

  ### Methods inherited from interface com.sas.services.information.metadata.ServerComponentInterface

  `getInitProcesses`

  ### Methods inherited from interface com.sas.services.information.metadata.ServerInterface

  `addComputeTask, addDataPackage, addProperty, addServed, addServer, addServiceType, addSourceConnection, getApplicationProtocol, getClassIdentifier, getComputeTasks, getConnectionProperties, getDataPackages, getDescriptiveComponent, getHost, getInstallationLocation, getIsLicensed, getMachine, getPlatform, getProperties, getProperties, getProperty, getServed, getServers, getServiceTypeObjects, getServiceTypes, getSourceConnections, getTcpPort, removeComputeTask, removeDataPackage, removeProperty, removeServed, removeServer, removeServiceType, removeSourceConnection, setApplicationProtocol, setClassIdentifier, setHost, setInstallationLocation, setIsLicensed, setMachine, setPlatform, setTcpPort`

  ### Methods inherited from interface com.sas.services.information.metadata.SoftwareComponentInterface

  `addDeployedComponent, addPropertyGroup, addSoftwareGroup, addSoftwareTree, getDependentComponents, getDependsOnComponents, getDeployedComponents, getImplementedObjects, getMajor, getMinor, getPrivateConfigurableProperties, getProductIdentifier, getProductName, getPropertyGroups, getPublicConfigurableProperties, getSoftwareComponentAttributes, getSoftwareGroups, getSoftwareTrees, getSoftwareVersion, getSpecVendor, getSpecVersion, getVendor, getVendorIdentifier, removeDeployedComponent, removePropertyGroup, removeSoftwareGroup, removeSoftwareTree, setDeployedComponents, setImplementedObjects, setMajor, setMinor, setProductIdentifier, setProductName, setPropertyGroups, setSoftwareComponentAttributes, setSoftwareGroups, setSoftwareTrees, setSoftwareVersion, setSpecVendor, setSpecVersion, setVendor, setVendorIdentifier`

- ## Field Details

  - ### METADATA_AUTHENTICATION_TYPE

    static final String METADATA_AUTHENTICATION_TYPE
    Constant used for the value of the `AuthenticationType` attribute of a `TCPIPConnection` to denote the type of authentication for this server. This authentication type indicates that the HTTP server is configured to authenticate against the Metadata server. A one time use password should be generated when authenticating to the HTTP server.
    See Also:
      - Constant Field Values

  - ### USERPASS_AUTHENTICATION_TYPE

    static final String USERPASS_AUTHENTICATION_TYPE
    Constant used for the value of the `AuthenticationType` attribute of a `TCPIPConnection` to denote the type of authentication for this server. This is the default authentication type for any HTTP server. If the authentication type does not match METADATA_AUTHENTICATION_TYPE or NONE_AUTHENTICATION_TYPE, then the default should be USERPASS_AUTHENTICATION_TYPE.

    The normal usage scenario for this authentication type, is that the username and password used to bind to the HTTP server are obtained from the user context based on the authentication domain of the HTTP server.

    See Also:
      - Constant Field Values

  - ### NONE_AUTHENTICATION_TYPE

    static final String NONE_AUTHENTICATION_TYPE
    Constant used for the value of the `AuthenticationType` attribute of a `TCPIPConnection` to denote the type of authentication for this server. This authentication types indicates that the HTTP server does not require any authentication so no credentials are needed when binding to the server.
    See Also:
      - Constant Field Values

- ## Method Details

  - ### getUrl

    String getUrl() throws ServiceException, RemoteException
    Get the url for this HTTP server.

    Returns:
      The url.
    Throws:
      `ServiceException` - if a service level error occurs.
      `RemoteException` - in the event of remote object failure.

  - ### setProxyUrl

    void setProxyUrl(String proxyUrl) throws ServiceException, RemoteException
    Set the proxy url for this HTTP server.

    Parameters:
      `proxyUrl` - The proxy url.
    Throws:
      `ServiceException` - if a service level error occurs.
      `RemoteException` - in the event of remote object failure.

  - ### getProxyUrl

    String getProxyUrl() throws ServiceException, RemoteException
    Get the proxy url.

    Returns:
      TThe proxy url.
    Throws:
      `ServiceException` - if a service level error occurs.
      `RemoteException` - in the event of remote object failure.

  - ### getDomains

    List getDomains() throws ServiceException, RemoteException
    Get a list of the authentication domains that the server is running in.

    Specified by:
      `getDomains` in interface `ServerInterface`
    Returns:
      a List of Strings with the names of the authentication domains the server is running in.
    Throws:
      `ServiceException` - if a service level error occurs.
      `RemoteException` - in the event of remote object failure.

  - ### getAuthenticationType

    String getAuthenticationType() throws ServiceException, RemoteException
    Get the authentication type string for the connection.
    Returns:
      The authentication type string.
    Throws:
      `ServiceException` - If a server error occurs.
      `RemoteException` - In the event of remote object failure.

  - ### setAuthenticationType

    void setAuthenticationType(String authType) throws ServiceException, RemoteException
    Set the authentication type string.
    Parameters:
      `authType` - The authentication type string.
    Throws:
      `ServiceException` - If a server error occurs.
      `RemoteException` - In the event of remote object failure.